commit 046501dc30f9b0fe31385698af4fd27b464af6ba
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Aug 4 11:33:18 2020 +0200

    veclower: Don't ICE on .VEC_CONVERT calls with no lhs [PR96426]
    
    .VEC_CONVERT is a const internal call, so normally if the lhs is not used,
    we'd DCE it far before getting to veclower, but with -O0 (or perhaps
    -fno-tree-dce and some other -fno-* options) it can happen.
    But as the internal fn needs the lhs to know the type to which the
    conversion is done (and I think that is a reasonable representation, having
    some magic another argument and having to create constants with that type
    looks overkill to me), we just should DCE those calls ourselves.
    During veclower, we can't really remove insns, as the callers would be
    upset, so this just replaces it with a GIMPLE_NOP.
    
    2020-08-04  Jakub Jelinek  <jakub@redhat.com>
    
            PR middle-end/96426
            * tree-vect-generic.c (expand_vector_conversion): Replace .VEC_CONVERT
            call with GIMPLE_NOP if there is no lhs.
    
            * gcc.c-torture/compile/pr96426.c: New test.
    
    (cherry picked from commit 95f5a3258dd8a9584f2b10304f79441ef2d4c64c)

diff --git a/gcc/testsuite/gcc.c-torture/compile/pr96426.c b/gcc/testsuite/gcc.c-torture/compile/pr96426.c
new file mode 100644
index 00000000000..bd573fe5366
--- /dev/null
+++ b/gcc/testsuite/gcc.c-torture/compile/pr96426.c
@@ -0,0 +1,10 @@
+/* PR middle-end/96426 */
+
+typedef long long V __attribute__((vector_size(16)));
+typedef double W __attribute__((vector_size(16)));
+
+void
+foo (V *v)
+{
+  __builtin_convertvector (*v, W);
+}
diff --git a/gcc/tree-vect-generic.c b/gcc/tree-vect-generic.c
index 8b00f325054..c1049203466 100644
--- a/gcc/tree-vect-generic.c
+++ b/gcc/tree-vect-generic.c
@@ -1717,6 +1717,12 @@ expand_vector_conversion (gimple_stmt_iterator *gsi)
   gimple *stmt = gsi_stmt (*gsi);
   gimple *g;
   tree lhs = gimple_call_lhs (stmt);
+  if (lhs == NULL_TREE)
+    {
+      g = gimple_build_nop ();
+      gsi_replace (gsi, g, false);
+      return;
+    }
   tree arg = gimple_call_arg (stmt, 0);
   tree ret_type = TREE_TYPE (lhs);
   tree arg_type = TREE_TYPE (arg);

